{{
Based on project 10 echo to pc
Clean up: pst taken out of project10.

GPS_IO_mini has pin0 fir TX; changed to pin10 
sd is mounted, header is added, file is appended when started again

repeat loop only worked with # repeats, but ok when opened and closed after each addition
LED indicates loop is running. 
}}

CON
  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
      
             ' Prop Chip Hookup: 
  D0  = 0   ' Connect to Pin 0                          ' I've set these pins to match the SD card holder connections
  CLK = 1   ' Connect to Pin 1                          ' These are the correct pin numbers for my SD Card holder
  DI  = 2   ' Connect to Pin 2                          ' In addition, connect the first pin (VDD) to +3.3 Volts, and
  CS  = 3   ' Connect to Pin 3                          ' connect the second pin (VSS) to ground.
                                                        ' My card holder has 6 pins (the 4 data lines, and 2 power lines.)
                                                        ' I got it from uController.com and it works very well.


OBJ
      gps  : "GPS_IO_mini echo all"
      fsrw : "fsrw"
      LED  : "LED"

pub demo | mount, data
    gps.start                                         'txpin changed 0=>10 ok
   
    mount := \fsrw.mount_explicit(D0, CLK, DI, CS)

    LED.Toggle(5, 50_000_000, 2)                     'Toggle(Pin, Delay, Count)
    
    fsrw.popen(string("log.txt"), "a")              ' opens File in Append
    fsrw.sdstr(String("TimeGMT,BoatSpeed, Heading,L/R,AWS,AWA,TWA,T/R, TWS"))
    fsrw.sdstr(string(" ",13,10))                    ' new line
    fsrw.pclose                                     ' close the file
              
    waitcnt(clkfreq*5 + cnt)                           


    repeat                                            '
      fsrw.popen(string("log.txt"), "a")              'opens File in Append
      fsrw.sdstr(gps.RMC0time)                            ' 
      fsrw.sdstr(string(","))
      'fsrw.sdstr(gps.latitude)
      'fsrw.sdstr(string(","))
      'fsrw.sdstr(gps.longitude)
      'fsrw.sdstr(string(","))  
      fsrw.sdstr(gps.RMC6bs)                            'bs, AWS, AWA for calculationss in Excel
      fsrw.sdstr(string(","))
      fsrw.sdstr(gps.RMC7heading)                          
      fsrw.sdstr(string(","))
      fsrw.sdstr(gps.VWR1LR)                                
      fsrw.sdstr(string(","))
      fsrw.sdstr(gps.VWR2AWS)                              
      fsrw.sdstr(string(","))
      fsrw.sdstr(gps.VWR0AWA)
      fsrw.sdstr(string(",")) 
      fsrw.sdstr(gps.MWV0TWA)
      fsrw.sdstr(string(",")) 
      fsrw.sdstr(gps.MWV1TR)
      fsrw.sdstr(string(",")) 
      fsrw.sdstr(gps.MWV2TWS)
      fsrw.sdstr(string(","))
      fsrw.sdstr(gps.MWV3)
      fsrw.sdstr(string(","))
      fsrw.sdstr(gps.MWV4)
      fsrw.sdstr(string(" ",13,10))

      fsrw.pclose                                      'close the file
 
      LED.Toggle(5, 500_00, 4)                        'Toggle(Pin, Delay, Count) LED flash => runs loop

      waitcnt(clkfreq*2 + cnt)                         '2 lines have identical timecode
                                                       'test: no shift when no wtcnt????